"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
function open(path, flags) {
    if (flags === void 0) { flags = 'r'; }
    return {
        enter: function () {
            return new Promise(function (resolve, reject) {
                fs.open(path, flags, function (err, fd) {
                    if (err)
                        return reject(err);
                    resolve(fd);
                });
            });
        },
        exit: function (err, fd) {
            if (err)
                return Promise.reject(err);
            return new Promise(function (resolve, reject) {
                fs.close(fd, function (err) {
                    if (err)
                        return reject(err);
                    resolve();
                });
            });
        },
    };
}
exports.open = open;
