export declare type EnterGuard<T> = () => T;
export declare type AsyncEnterGuard<T> = () => Promise<T>;
export declare type ExitGuard<T> = (err: Error | null, used: T) => void;
export declare type AsyncExitGuard<T> = (err: Error | null, used: T) => Promise<void>;
export interface ContextGuards<T> {
    enter: EnterGuard<T> | AsyncEnterGuard<T>;
    exit?: ExitGuard<T> | AsyncExitGuard<T>;
}
export declare type ContextGuardFunction<T> = () => T | [T, ExitGuard<T> | AsyncExitGuard<T> | undefined];
export declare type ContextGuard<T> = ContextGuards<T> | ContextGuardFunction<T>;
